package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name = "FISCAL_IMPRESSORA")
public class FiscalImpressora implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	@Basic(optional = false)
	@Column(name = "FISCALIMPRESSORA_ID")
	private Integer fiscalimpressoraId;
	
	@Column(name = "MARCA")
	private String marca;
	
	@Column(name = "MODELO")
	private String modelo;
	
	@Column(name = "VERSIONSB")
	private String versionsb;
	
	@Column(name = "CNIEE")
	private String cniee;
	
	@Column(name = "ACTIVO")
	private Boolean activo;
	
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	
	@Column(name = "NUMSERIE20")
	private String numserie20;
	
	@Column(name = "NUMEROIDENTIFICACAO")
	private String numeroIdentificacao;
	
    @JoinColumn(name = "ESTADOLOCAL_ID", referencedColumnName = "ESTADO_ID")
    @ManyToOne
    private Estado estado;
    
    @JoinColumn(name = "ESTADOLACRE_ID", referencedColumnName = "ESTADO_ID")
    @ManyToOne
    private Estado estadoLacre;
    
	@OneToOne
	@JoinColumn(name = "EMPRESA_ID")
	private Empresa empresa;
	
	@Column(name = "INDBLOQUEAECF")
	private Boolean indBloqueaECF;
	
	@Column(name = "INDVALIDAESTADO")
	private Boolean indValidaEstado;
	
	public FiscalImpressora() {
		super();
	}
	
	public FiscalImpressora(Integer fiscalimpressoraId) {
		this();
		setFiscalimpressoraId(fiscalimpressoraId);
	}

	public Integer getFiscalimpressoraId() {
		return fiscalimpressoraId;
	}

	public void setFiscalimpressoraId(Integer fiscalimpressoraId) {
		this.fiscalimpressoraId = fiscalimpressoraId;
	}

	public String getMarca() {
		return marca;
	}

	public void setMarca(String marca) {
		this.marca = marca;
	}

	public String getModelo() {
		return modelo;
	}

	public void setModelo(String modelo) {
		this.modelo = modelo;
	}

	public String getVersionsb() {
		return versionsb;
	}

	public void setVersionsb(String versionsb) {
		this.versionsb = versionsb;
	}

	public String getCniee() {
		return cniee;
	}

	public void setCniee(String cniee) {
		this.cniee = cniee;
	}

	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((fiscalimpressoraId == null) ? 0 : fiscalimpressoraId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof FiscalImpressora))
			return false;
		FiscalImpressora other = (FiscalImpressora) obj;
		if (fiscalimpressoraId == null) {
			if (other.fiscalimpressoraId != null)
				return false;
		} else if (!fiscalimpressoraId.equals(other.fiscalimpressoraId))
			return false;
		return true;
	}

	public String getNumserie20() {
		return numserie20;
	}

	public void setNumserie20(String numserie20) {
		this.numserie20 = numserie20;
	}

	public String getNumeroIdentificacao() {
		return numeroIdentificacao;
	}

	public void setNumeroIdentificacao(String numeroIdentificacao) {
		this.numeroIdentificacao = numeroIdentificacao;
	}

	public Estado getEstado() {
		return estado;
	}

	public void setEstado(Estado estado) {
		this.estado = estado;
	}

	public Estado getEstadoLacre() {
		return estadoLacre;
	}

	public void setEstadoLacre(Estado estadoLacre) {
		this.estadoLacre = estadoLacre;
	}

	public Empresa getEmpresa() {
		return empresa;
	}

	public void setEmpresa(Empresa empresa) {
		this.empresa = empresa;
	}

	public Boolean getIndBloqueaECF() {
		return indBloqueaECF;
	}

	public void setIndBloqueaECF(Boolean indBloqueaECF) {
		this.indBloqueaECF = indBloqueaECF;
	}

	public Boolean getIndValidaEstado() {
		return indValidaEstado;
	}

	public void setIndValidaEstado(Boolean indValidaEstado) {
		this.indValidaEstado = indValidaEstado;
	}
	
}
